package JSX;

import java.io.*;
import java.util.*;

/** Correct order is higher priorities first? Large->small, "decreasing order"
	* Note: Can't use "SortedSet", because can have more than one of same "value".
	* Question: this works to spec, but how to test it in situ?
	*
	* The messy commenting out below will remain, until at least one release
	* has passed - and same for the remanents of native approach in ObjIn.
	* But this new approach is definitely the right way to go!
	**/


/** Not public: only used from ObjIn **/
class ValidationList {
	public static void main(String[] arg) throws Exception {
		ValidationList v = new ValidationList();
		v.register(null, 1);
		v.register(null, 2);
		v.register(null, 2);
		v.register(null, -1);
		v.register(null, 1);
		v.register(null, -1);
		v.register(null, 99);
		v.register(null, 1);
		v.register(null, -1);

		v.doCallbacks();
	}

	private static class Callback implements Comparable {
		final ObjectInputValidation obj;
		final int priority;
		private Callback(ObjectInputValidation obj, int priority) {
			this.obj = obj;
			this.priority = priority;
		}
		public int compareTo(Object obj) {	// >0 if this>obj; -ve for decreasing
			int cmp = -(this.priority-((Callback)obj).priority);
		//	if (cmp==0) return 1;	// never == (ugly potentially dangerous hack)
		//	else
			return cmp;
		}
//		public boolean equals(Object obj) {	// >0 if this>obj; want reverse, so -ve
//			return this.priority==((Callback)obj).priority;	// javanut says needed
//		}
	}

	//private SortedSet list = new TreeSet();
	private List list = new LinkedList();

	void register(ObjectInputValidation obj, int priority) throws InvalidObjectException {
		if (obj==null)
			throw new InvalidObjectException("null callback");
		list.add(new Callback(obj, priority));
	}

	void doCallbacks() throws InvalidObjectException {
		Collections.sort(list);
//		try {
			Iterator it = list.iterator();	// style from JPL
			while (it.hasNext()) {
				//System.err.println(((Callback)it.next()).priority);
				((Callback)it.next()).obj.validateObject();
			}
//		} finally {
//			clear();	// free the objects	-> actually, we can rely on readObject
//		}
	}

	void clear() {
		list.clear();
	}
}
