<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>IMTM Brainstorming WebClient</title>

    <link rel="stylesheet" type="text/css" href="/yui3/cssreset/reset-min.css" />
    <link rel="stylesheet" type="text/css" href="/yui3/cssfonts/fonts-min.css" />

	<style type="text/css">
        @import "style/brainstorming.css";
        @import "style/brainstorming-blue.css";
    </style>
    
	<!-- Bibliotheken -->
	<script type="text/javascript" src="/yui3/yui/yui.js"></script>

	<!-- Globales YUI Objekt, das von unserem Server nachldt -->
	<script type="text/javascript" src="brainstorming-config.js"></script>

    <script type="text/x-template" id="prompts-template">
        <div id='prompts-head-{id}' class='panel-head clickable'>
            <table>
                <tr>
                    <td>
                        <div class='prompts-label'>{PROMPT}</div>
                    </td>
                    <td class='action'>
                        <div class=''>+</div>
                    </td>
                </tr>
            </table>
        </div>
        <div class='panel-body' id='prompt-div-{id}'>
            <div class='content-body all-prompts-body' id='all-prompts-{id}'>{{PROMPTS}}</div>
        </div>
    </script>
    
    <script type="text/x-template" id="card-editor-template">
        <div class='panel-head' id='legend-{id}'>{CREATE_CARD}</div>
        <div class='panel-body' id='editor-{id}'>
            <table style="width: 100%;">
                <tr>
                    <td style="width: 15%;">
                        <label for='text-{id}'>{TEXT}:</label>
                    </td>
                    <td style="width: auto; padding-right: 10px;">
                        <input type='text' style="width: 100%;" id='text-{id}'/>
                    </td>
                    <td rowspan="2">
                        <input type='button' class="send-button clickable" value='{SEND}' id='send-{id}' />
                    </td>
                </tr>
                <tr>
                    <td>
                        <label style='float: left; width: 15%;' for='type-{id}'>{CARD_TYPE}:</label>
                    </td>
                    <td>
                        <select id='type-{id}' style=''>
                            <option value='META'>{META_ELEMENT}</option>
                            <option value='ACTIVITY'>{ACTIVITY}</option>
                            <option value='ENTITY' selected='selected'>{ENTITY}</option>
                            <option value='ROLE'>{ROLE}</option>
                            <option value='MODIFIER'>{BASICMODIFIER}</option>
                        </select>
                    </td>
                </tr>
            </table>
        </div>
    </script>
    
    <script type="text/x-template" id="card-history-template">
        <div class='panel-head clickable' id='history-head-{id}'>
            <table>
                <tr>
                    <td>
                        <div class='prompts-label'>{HISTORY}</div>
                    </td>
                    <td class='action'>
                        <div class=''>+</div>
                    </td>
                </tr>
            </table>
        </div>
        <div class='panel-body' id='card-history-{id}'></div>
    </script>

    <script type="text/x-template" id="topic-template">
        <li class='topic-item'>
            <!--
            Header
            -->
            <div class='panel-head clickable' id='topic-head-{id}'>
                <table>
                    <tr>
                        <td>
                            <div class='topic-panel-label' id='topic-label-{id}'>{topic}</div>
                        </td>
                        <td class='action'>
                            <div id='topic-toggle-{id}' class="toggle open"></div>
                        </td>
                    </tr>
                </table>
            </div>

            <!-- Body -->
            <div id='topic-body-{id}' class='panel-body topic-body'>
                <div id='topic-prompts-container-{id}' class='panel-container prompts-container'></div>
                <div id='topic-card-editor-container-{id}' class='panel-container card-editor-container'></div>
                <div id='topic-card-history-container-{id}' class='panel-container card-history-container'></div>
            </div>
        </li>
    </script>
	

    <script type="text/javascript">
    	YUI().use("node", "brainstorming-client", "brainstorming-view", "gallery-io-poller", "json", function(Y) {
    		Y.on("domready", function() {
                var client = new Y.BrainstormingClient();
                var topics = {};
                
    			var poller = Y.io.poll(1000, "rest/topics?client-id=" + client.getClientId(), {
    				on: {
    					success: function(txId, r, args) {
    						if (r.status != 200) {
    							return;
    						}
    						
    						var newTopics = Y.JSON.parse(r.responseText);
    						for (var t in topics) {
    							var found = false;
    							for (var i in newTopics) {
    								var topic = newTopics[i];
    								if (t == topic.id) {
    									found = true;
    									break;
    								}
    							}
    							
    							if (!found) {
    								var topicData = topics[t];
    								topicData.view.destroy();
    								delete topics[t];
    							}
    						}
    						
    						for (var i in newTopics) {
    							var topic = newTopics[i];
    							if (topics[topic.id]) {
    								var model = topics[topic.id].model;
    								model.set('topic', topic.name);
    							} else {
    								var model = new Y.TopicModel({
    									topic: topic.name,
    									id: topic.id
    								});
    								var view = new Y.TopicView({
    									model: model,
    									container: Y.one("#topics")
    								});
    								view.render();
    								var topicData = {
    									model: model,
    									view: view
    								};
    								topics[topic.id] = topicData;
    								model.after('topic-model:viewingChange', function(e) {
    									if (e.newVal == false) {
    										return;
    									}
    									
    									var modelId = e.target.get('id');
    									for (var id in topics) {
    										if (id == modelId) {
    											continue;
    										}
    										
    										topics[id].model.set('viewing', false);
    									}
    								}, this);
    							}
    						}
    					}
    				},
    				headers: { 
    					'Accept': 'application/json' 
    				}, 
    				context: this
    			});
    			
    			poller._modifiedDate = 'Thu, 01 Jan 1970 00:00:00 GMT';
    			poller.set('pauseInactive', true);
    			poller.start();
	
	    		//var client = new Y.Client();
	    		//var topicController = new Y.TopicController(client);
/*
                var topicModel1 = new Y.TopicModel({
                    topic: "Topic #1: Lorem ipsum, lorem ipsum",
                    id: "1"
                });
                var topicView1 = new Y.TopicView({
                    model: topicModel1,
                    container: Y.one("#topics")
                });
                topicView1.render();

                var topicModel2 = new Y.TopicModel({
                    topic: "Topic #2: Lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum, lorem ipsum",
                    id: "2"
                });
                var topicView2 = new Y.TopicView({
                    model: topicModel2,
                    container: Y.one("#topics")
                });
                topicView2.render();

                var tml = new Y.TopicModelList();
                tml.load();*/
    		}, Y);
    	});
    </script>
</head>
<body class="yui3-skin-sam">
	<div id="head">IMTM Brainstorming WebClient</div>
	<ul id="topics" class="panel-container"></ul>
</body>
</html>
