YUI.add("card-editor-view", function (Y) {

	Y.CardEditorView = Y.Base.create('card-editor-view', Y.View, [], {

		container: '<div class="card-editor-item" />',

		template: Y.one("#card-editor-template").getContent(),

		events: {

		},

		initializer: function () {
			var model = this.get('model'),
				modelId = model.get('id'),
				strings = Y.merge(Y.Intl.get('card-editor-view'), {
					id: modelId
				}),
				html = Y.substitute(this.template, strings),
				node = Y.Node.create(html);
			
			this.get('container').append(node);
			this._node = node;
		},

		render: function () {
			var container = this.get('container'),
				model = this.get('model'),
				modelId = model.get('id'),
				input = container.one('#text-' + modelId);
			
			container.one('#send-' + modelId).after('click', this.createCard, this);
			model.after('topic-model:viewingChange', this.update, this);

			this.update();
			return this;
		},

		// -- Event Handlers -------------------------------------------------------
		
		update: function() {
			var container = this.get('container'),
				model = this.get('model'),
				modelId = model.get('id'),
				input = container.one('#text-' + modelId);
				
			if (model.get('viewing')) {
				input.focus();
			}
		},

		createCard: function(e) {
			var container = this.get('container'),
				model = this.get('model'),
				modelId = model.get('id'),
				text = container.one('#text-' + modelId).get('value'),
				type = container.one('#type-' + modelId).get('value');
			
			model.addCard(type, text);
		}
	});

}, "1.0");
