var defaultLang = {
	"PROMPT" : "Prompt",
	"CREATE_CARD" : "Create Card",
	"TEXT" : "Text",
	"CARD_TYPE" : "Type",
	"META_ELEMENT" : "neutral Card",
	"ACTIVITY" : "Activity",
	"ENTITY" : "Entity",
	"ROLE" : "Role",
	"BASICMODIFIER" : "Modifier",
	"SEND" : "Send",
	"HISTORY" : "History",
	"EMPTY_TEXT_ERROR" : "Text must not be empty!",
	"NEXT_PROMPT" : "Request next Prompt",
	"YOUR_COMMENT" : "Your comment",
	"ADD_COMMENT" : "Add",
	"EDIT_COMMENT" : "Edit",
	"CLOSED_INFO" : "This topic is closed and does not accept further cards."
};

var langDE = {
	"PROMPT" : "Prompt",
	"CREATE_CARD" : "Karte erstellen",
	"TEXT" : "Text",
	"CARD_TYPE" : "Typ",
	"META_ELEMENT" : "neutrale Karte",
	"ACTIVITY" : "Aktivit&auml;t",
	"ENTITY" : "Entit&auml;t",
	"ROLE" : "Rolle",
	"BASICMODIFIER" : "Modifikator",
	"SEND" : "Senden",
	"HISTORY" : "Verlauf",
	"EMPTY_TEXT_ERROR" : "Text darf nicht leer sein!",
	"NEXT_PROMPT" : "n&auml;chster Prompt",
	"YOUR_COMMENT" : "Kommentar",
	"ADD_COMMENT" : "Hinzuf&uuml;gen",
	"EDIT_COMMENT" : "Bearbeiten",
	"CLOSED_INFO" : "Die Frage ist geschlossen und akzeptiert keine weiteren Karten mehr."
};

var langs = {
	"en": defaultLang,
	"de": langDE
};

function getLang(lang) {
	if ((lang == undefined) || (lang == null)){
		lang = LANG;
	}
	var l = langs[lang];
	if ((l == undefined) || (l == null)) {
		l = defaultLang;
	}
	
	return l;
}

function localizeTemplate(template, lang) {
	var l = getLang(lang);
	
	return template.replace(/{{.*?}}/g, function(m) {
		k = m.substring(2, m.length - 2);
		if (l[k]) {
			return l[k];
		} else {
			return m;
		}
	});
}

function getLocalizedString(key, lang) {
	var l = getLang(lang);
	
	return l[key];
}