var CARD_TEMPLATE =
	"<div id=\'card-{{ID}}\' class=\'history-entry\'> \n" + 
	"	<div class=\'history-entry-content\'> \n" + 
	"		<div style=\'font-size: small;\'>{{DATE}}:</div> \n" + 
	"		<span id=\'text-{{ID}}\'>{{TEXT}}</span> \n" + 
	"	</div> \n" + 
	"	<div class=\'history-entry-state\'> \n" + 
	"		<div class=\'state state-sent\' id=\'state-{{ID}}\'></div> \n" + 
	"	</div> \n" + 
	"	<div style=\'clear: both;\'>\n" +
	"		{{YOUR_COMMENT}} [<a href=\'#\' id=\'comment-add-{{ID}}\'>{{ADD_COMMENT}}</a>]:<br />\n" +
	"		<div id=\'comment-wrapper-{{ID}}\'>\n" +
	"			<div id=\'comment-text-{{ID}}\'></div>\n" +
	"		</div>\n" +
	"	</div> \n" + 
	"</div>";

SeeMeYUI.use("node", "datatype-date", function(Y) {
	
	function replaceAll(txt, replace, with_this) {
		return txt.replace(new RegExp(replace, 'g'),with_this);
	}

	Card = function(type, text, topic) {
		this.nodeId = new UUID().toString();
		this.date = new Date();
		this.type = type;
		this.text = text;
		this.state = 'sent';
		this.topic = topic;
		
		var html = CARD_TEMPLATE.replace(/{{TEXT}}/g, this.text);
		html = html.replace(/{{ID}}/g, this.nodeId);
		html = html.replace(/{{DATE}}/g, Y.DataType.Date.format(this.date, { format: "%x %X" }));
		html = localizeTemplate(html);
		
		var node = Y.Node.create(html);
		this.node = node;
	};
	
	Card.prototype = {

		getId: function() { return this.id; },
		getType: function() { return this.type; },
		getText: function() { return this.text; },
		getHistoryHtmlElement: function() { return this.node; },
		
		setId: function(id) { this.id = id; },
		
		getChildNodeByName: function(name) {
			if (!name) {
				return;
			}
			
			return this.node.one(name + this.nodeId);
		},
		
		setState: function(s) {
			var stateNode = this.getChildNodeByName("#state-");
			stateNode.removeClass('state-' + this.state);
			stateNode.addClass('state-' + s);
			this.state = s;
		},
		
		init: function(parent) {
			this._parent = parent;
			console.log("init ctx", this);
			var addCommentNode = this.getChildNodeByName("#comment-add-"),
				commentTextNode = this.getChildNodeByName("#comment-text-");
			
			if (addCommentNode) {
				addCommentNode.on("click", this.addComment, this);
			}
			
			if (this.comment && (this.comment.text && (this.comment.text != ""))) {
				addCommentNode.set("text", localizeTemplate("{{EDIT_COMMENT}}"));
				commentTextNode.set("text", this.comment.text);
			} else {
				addCommentNode.set("text", localizeTemplate("{{ADD_COMMENT}}"));
			}
		},
		
		resizeTopics: function(ctx) {
			ctx.get("context")._parent.resize();
			ctx.focus();
			ctx.select();
		},
		
		addComment: function(e) {
			SeeMeYUI.COMMENT_EDITOR_PANEL.commentCard(this);
			SeeMeYUI.COMMENT_EDITOR_PANEL.show();
		},
		
		updateComment: function(ioId, o, ctx) {
			var result = Y.JSON.parse(o.responseText),
				ac = this.getChildNodeByName("#comment-add-"),
				ct = this.getChildNodeByName("#comment-text-");
			
			ct.set("innerHTML", replaceAll(ctx.comment, "\n", "<br />"));
			this.comment = result;

			if (this.comment && (this.comment.text && (this.comment.text != ""))) {
				ac.set("text", localizeTemplate("{{EDIT_COMMENT}}"));
				ct.set("text", this.comment.text);
			} else {
				ac.set("text", localizeTemplate("{{ADD_COMMENT}}"));
			}
			
			this._parent.resize();
		},
		
		setComment: function(text) {
			var sessionController = this.topic.getTopicController().getSessionController(),
				session = sessionController.getCurrentSession(),
				clientId = sessionController.getParticipantId(),
				sessionId = session.id;
			
			var data = {
				'text' : text,
				'client-id': clientId
			};
			if (this.comment && this.comment.id) {
				data['id'] = this.comment.id;
			};
			alert(data);
			
			var json = Y.JSON.stringify(data);
			
			var cfg = {
				method: 'PUT',
				headers: { 'Content-Type': 'application/json' },
				data: json,
				on: {
					success: this.updateComment,
					failure: this.handleFailure
				},
				arguments: {
					comment: text
				},
				context: this
			};
			
			Y.io.queue.stop();
			Y.io.queue("rest/sessions/" + sessionId + "/topics/" + this.topic.getId() + "/cards/" + this.id + "/comment", cfg);
			Y.io.queue.start();
		},
		
		handleFailure: function(e) {
			
		}
	};
	
});
